-- General vars --
gps_zoom = 10
AIRP_Status = true -- Activated by default
VOR_Status = false
NDB_Status = false
FIX_Status = false
MAP_Number = 1 -- MAPQUEST by Default

-- Button functions --
function new_zoomplus()
	gps_zoom = gps_zoom + 1
	if (gps_zoom > 14) then
		gps_zoom = 14
	end
	map_zoom(navmap, gps_zoom)
	if MAP_Number == 1 then
		txt_set(mode_terrain_zoom,"TERRAIN / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 190,490,250,50)		
	elseif  MAP_Number == 2 then
		txt_set(mode_terrain_zoom,"TRANSPORT / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;",  190,490,250,50)	
	elseif  MAP_Number == 3 then
		txt_set(mode_terrain_zoom,"STANDARD / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;",  190,490,250,50)	
	elseif MAP_Number == 4 then
		txt_set(mode_terrain_zoom,"CYCLE / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;",  190,490,250,50)	
	end
end

function new_zoommin()
	gps_zoom = gps_zoom - 1
	if (gps_zoom < 7) then
		gps_zoom = 7
	end
	map_zoom(navmap, gps_zoom)
	if MAP_Number == 1 then
		txt_set(mode_terrain_zoom,"TERRAIN / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 190,490,250,50)		
	elseif  MAP_Number == 2 then
		txt_set(mode_terrain_zoom,"TRANSPORT / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;",  190,490,250,50)	
	elseif  MAP_Number == 3 then
		txt_set(mode_terrain_zoom,"STANDARD / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;",  190,490,250,50)	
	elseif MAP_Number == 4 then
		txt_set(mode_terrain_zoom,"CYCLE / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;",  190,490,250,50)	
	end
end

function new_home()
	gps_zoom = 10
	map_zoom(navmap, gps_zoom)
end

function MAP_Up()
	MAP_Number  = MAP_Number  + 1
	if (MAP_Number > 4) then
		MAP_Number = 4
	end
	if MAP_Number == 1 then
		map_baselayer(navmap, "OSM_MAPQUEST")
		txt_set(mode_terrain_zoom,"TERRAIN / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 190,490,250,50)		
	elseif  MAP_Number == 2 then
		txt_set(mode_terrain_zoom,"TRANSPORT / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;",  190,490,250,50)	
		map_baselayer(navmap,"OSM_TRANSPORT") 
	elseif  MAP_Number == 3 then
		txt_set(mode_terrain_zoom,"STANDARD / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;",  190,490,250,50)	
		map_baselayer(navmap,"OSM_STANDARD" )
	elseif MAP_Number == 4 then
		txt_set(mode_terrain_zoom,"CYCLE / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;",  190,490,250,50)	
		map_baselayer(navmap,"OSM_CYCLE")
	end
end
function MAP_Down()
	MAP_Number  = MAP_Number  -1
	if (MAP_Number < 1) then
		MAP_Number = 1
	end
	if MAP_Number == 1 then
		map_baselayer(navmap, "OSM_MAPQUEST")
		txt_set(mode_terrain_zoom,"TERRAIN / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;",  190,490,250,50)		
	elseif  MAP_Number == 2 then
		txt_set(mode_terrain_zoom,"TRANSPORT / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;",  190,490,250,50)	
		map_baselayer(navmap,"OSM_TRANSPORT") 
	elseif  MAP_Number == 3 then
		txt_set(mode_terrain_zoom,"STANDARD / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;",  190,490,250,50)	
		map_baselayer(navmap,"OSM_STANDARD" )
	elseif MAP_Number == 4 then
		txt_set(mode_terrain_zoom,"CYCLE / Zoom " .. gps_zoom ,"-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;",  190,490,250,50)	
		map_baselayer(navmap,"OSM_CYCLE")
	end
end

function AIRP_Active()
	if AIRP_Status == false then
		AIRP_id_icon   = map_add_nav_img_layer(navmap, "AIRP", "airport.png", -13, -13, 26, 26)
		AIRP_id_name = map_add_nav_txt_layer(navmap, "AIRP", "NAME", "-fx-font-size:09px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;  -fx-text-alignment:center; -fx-stroke: black; -fx-stroke-width: 1;", -40, -30, 80, 40)
		txt_add("AIP","-fx-font-size:09px; -fx-fill: green; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 19,100,30,30)
		AIRP_Status = true
	end
end
function AIRP_Inactive()
	if AIRP_Status == true then
		visible(AIRP_id_icon,visible)
		visible(AIRP_id_name,visible)
		txt_add("AIP","-fx-font-size:09px; -fx-fill: White; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 19,100,30,30)
		AIRP_Status = false
	end
end
function VOR_Active()
	if VOR_Status == false then
		VOR_id_icon   = map_add_nav_img_layer(navmap, "VOR", "VOR-DME.png", -10, -10, 20, 20)
		VOR_id_name = map_add_nav_txt_layer(navmap, "VOR", "NAME", "-fx-font-size:09px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;  -fx-text-alignment:center; -fx-stroke: black; -fx-stroke-width: 1;", -40, -30, 80, 40)
		txt_add("VOR","-fx-font-size:09px; -fx-fill: green; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 19,180,30,30)
		VOR_Status = true
	end
end
function VOR_Inactive()
	if VOR_Status == true then
		visible(VOR_id_icon,visible)
		visible(VOR_id_name,visible)
		txt_add("VOR","-fx-font-size:09px; -fx-fill: White; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 19,180,30,30)
		VOR_Status = false
	end
end
function NDB_Active()
	if NDB_Status == false then
		NDB_id_icon   = map_add_nav_img_layer(navmap, "NDB", "NDB.png", -10, -10, 20, 20)
		NDB_id_name = map_add_nav_txt_layer(navmap, "NDB", "NAME", "-fx-font-size:09px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;  -fx-text-alignment:center; -fx-stroke: black; -fx-stroke-width: 1;", -40, -30, 80, 40)
		txt_add("NDB","-fx-font-size:09px; -fx-fill: green; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 19,260,30,30)
		NDB_Status = true
	end
end
function NDB_Inactive()
	if NDB_Status == true then
		visible(NDB_id_icon,visible)
		visible(NDB_id_name,visible)
		txt_add("NDB","-fx-font-size:09px; -fx-fill: White; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 19,260,30,30)
		NDB_Status = false
	end
end
function FIX_Active()
	if FIX_Status == false then
		FIX_id_icon   = map_add_nav_img_layer(navmap, "FIX", "FIX.png", -10, -10, 20, 20)
		FIX_id_name = map_add_nav_txt_layer(navmap, "FIX", "NAME", "-fx-font-size:09px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;  -fx-text-alignment:center; -fx-stroke: black; -fx-stroke-width: 1;", -40, -30, 80, 40)
		txt_add("FIX","-fx-font-size:09px; -fx-fill: green; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 19,340,30,30)
		FIX_Status = true
	end
end
function FIX_Inactive()
	if FIX_Status == true then
		visible(FIX_id_icon,visible)
		visible(FIX_id_name,visible)
		txt_add("FIX","-fx-font-size:09px; -fx-fill: White; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 19,340,30,30)
		FIX_Status = false
	end
end
-------------------------------------
-- Load and display map and images --
-------------------------------------
img_add_fullscreen("GPSback.png")
img_add("zoomgps.png",531,310,32,78)
txt_add("Zoom","-fx-font-size: 09px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 534,342,30,20)
img_add("zoomgps.png",13,70,32,78) -- Airport
txt_add("AIP","-fx-font-size:09px; -fx-fill: Green; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 19,100,30,30)
img_add("zoomgps.png",13,150,32,78)   -- VOR
txt_add("VOR","-fx-font-size:09px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 19,180,30,30)
img_add("zoomgps.png",13,230,32,78) -- NDB
txt_add("NDB","-fx-font-size:09px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 19,260,30,30)
img_add("zoomgps.png",13,310,32,78) -- FIX
txt_add("FIX","-fx-font-size:09px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 19,340,30,20)
img_add("zoomgps.png",531,230,32,78) -- FIX
txt_add("Map","-fx-font-size:09px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 534,260,30,20)

----------------------------------------------** MAP OPTIONS START **----------------------------------------------
-- Change zoom level '...OSM_MAPQUEST",zoom level)' to set your preferred zoom level, lower is out, higher is in --
-- Change map type '...,"map type",12)' to set your preferred map type. See the wiki for the options.            --
-- http://airrietveld.nl/wiki/                                                                                   --
-------------------------------------------------------------------------------------------------------------------

navmap = map_add(80,122,415,351,"OSM_MAPQUEST" ,gps_zoom) -- MAP_List(1) = OSM_MAPQUEST by Default
-- txt_add("Mode TERRAIN / Zoom " .. gps_zoom,"-fx-font-size:14px; -fx-fill: Blue; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 170,490,250,50)
mode_terrain_zoom = txt_add("Mode TERRAIN / Zoom " .. gps_zoom, "-fx-font-size:14px; -fx-fill: Yellow; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 190 ,490,250,50)
---------------------------------------------**** MAP OPTIONS END ****---------------------------------------------
-------------------------------------------------------------------------------------------------------------------

AIRP_id_icon   = map_add_nav_img_layer(navmap, "AIRP", "airport.png", -13, -13, 26, 26)
AIRP_id_name  = map_add_nav_txt_layer(navmap, "AIRP", "NAME", "-fx-font-size:09px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;  -fx-text-alignment:center; -fx-stroke: black; -fx-stroke-width: 1;", -40, -30, 80, 40)
img_add("northarrow.png", 90, 130, 25, 25)
airplane_icon = img_add("airplane.png", 275, 285, 25, 25)
---------------------------
-- Load and display text --
---------------------------
txt_add("N","-fx-font-size:12px; -fx-fill: black; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;", 98,134,20,20)
txt_add("DG","-fx-font-size:18px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;  -fx-text-alignment:center; -fx-stroke: black; -fx-stroke-width: 1;", 394,130,100,50)
txt_heading = txt_add(" ","-fx-font-size:22px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;  -fx-text-alignment:center; -fx-stroke: black; -fx-stroke-width: 1;", 394,145,100,50)
txt_add("GS","-fx-font-size:18px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;  -fx-text-alignment:center; -fx-stroke: black; -fx-stroke-width: 1;", 90,420,100,50)
txt_ground_speed = txt_add(" ","-fx-font-size:22px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;  -fx-text-alignment:center; -fx-stroke: black; -fx-stroke-width: 1;", 90,435,100,50)
txt_TFT = txt_add("TFT","-fx-font-size:18px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;  -fx-text-alignment:center; -fx-stroke: black; -fx-stroke-width: 1;", 391,410,100,50)
txt_totfltm = txt_add("00:00","-fx-font-size:22px; -fx-fill: white; -fx-font-family:\"Arial Black\"; -fx-font-weight: bold;  -fx-text-alignment:center; -fx-stroke: black; -fx-stroke-width: 1;", 340,425,200,50)
txt_mode = txt_add(" ","-fx-font-size:22px; -fx-fill: #b6cfe5; -fx-font-family: Arial; -fx-font-weight: bold;  -fx-text-alignment:center;", 305,88,200,50)
txt_radioalt = txt_add(" ","-fx-font-size:22px; -fx-fill: #00ff00; -fx-font-family: Arial; -fx-font-weight: bold;  -fx-text-alignment:center;", 305,50,200,50)
txt_nav1 = txt_add(" ","-fx-font-size:22px; -fx-fill: #00ff00; -fx-font-family: Arial; -fx-font-weight: bold;  -fx-text-alignment:center;", 170,50,200,50)
txt_nav1stby =  txt_add(" ","-fx-font-size:22px; -fx-fill: #b6cfe5; -fx-font-family: Arial; -fx-font-weight: bold;  -fx-text-alignment:center;", 170,88,200,50)
txt_com1 = txt_add(" ","-fx-font-size:22px; -fx-fill: #00ff00; -fx-font-family: Arial; -fx-font-weight: bold;  -fx-text-alignment:center;", 79,50,200,50)
txt_com1stby =  txt_add(" ","-fx-font-size:22px; -fx-fill: #b6cfe5; -fx-font-family: Arial; -fx-font-weight: bold;  -fx-text-alignment:center;", 79,88,200,50)
txt_hpa = txt_add(" ","-fx-font-size:22px; -fx-fill: #b6cfe5; -fx-font-family: Arial; -fx-font-weight: bold;  -fx-text-alignment:center;", 346,490,200,50)
txt_OAT = txt_add(" ","-fx-font-size:22px; -fx-fill: #b6cfe5; -fx-font-family: Arial; -fx-font-weight: bold;  -fx-text-alignment:center;", 27,490,200,50)

---------------
-- Functions --
---------------

function new_position(latitude, longitude, heading, groundspeed, timer)
-- Set position on world map --
	map_goto(navmap, longitude, latitude)
-- Rotate airplane icon to current heading --
	img_rotate(airplane_icon, heading)
-- Set heading text --
	txt_set(txt_heading, string.format("%01d" .. "\194\176", heading) )
-- Set groundspeed text --
	txt_set(txt_ground_speed, string.format("%01d" .. " KT", groundspeed) )
-- Set flight time text HH:MM --
	if timer == 0 then
		txt_set(txt_TFT, " ")
		txt_set(txt_totfltm, " ")
	else
		txt_set(txt_TFT, "TFT")
		txt_set(txt_totfltm, string.format("%02d:%02d",(timer / 3600), ( (timer / 60) % 60) ) )
	end
end

function new_navcomm(mode, radioalt, nav1, nav1stby, com1, com1stby, outsideAT, baro)
-- Transponder mode --
	if mode == 0 then
		txt_set(txt_mode, "OFF")
	elseif mode == 1 then
		txt_set(txt_mode, "STBY")
	elseif mode == 2 then
		txt_set(txt_mode, "ON")
	elseif mode == 3 then
		txt_set(txt_mode, "ALT")
	elseif mode == 4 then
		txt_set(txt_mode, "TST")
	end
-- Radio altimeter --
	if radioalt < 5000 then
		txt_set(txt_radioalt, string.format("%01d", radioalt) )
	else
		txt_set(txt_radioalt, "FL" .. string.format("%01d",radioalt/100 ))
	end
-- Frequency text set ---
	txt_set(txt_nav1,  string.format("%d.%.02d",nav1/100, nav1%100) )
	txt_set(txt_nav1stby,  string.format("%d.%.02d",nav1stby/100, nav1stby%100) )	

	txt_set(txt_com1,  string.format("%d.%.02d",com1/100, com1%100) )
	txt_set(txt_com1stby,  string.format("%d.%.02d",com1stby/100, com1stby%100) )

-- OAT and barometic setting --
	txt_set(txt_OAT,  string.format("%01d" .. "\° C", outsideAT) )
	txt_set(txt_hpa, string.format("%02d", baro * 33.8639) )
end

function new_navcomm_FSX(squawk, radioalt, nav1, nav1stby, com1, com1stby, outsideAT, baro)
	nav1 = nav1 / 10
	nav1stby = nav1stby / 10
	com1 = com1 / 10
	com1stby = com1stby / 10
	if squawk >0 then
		mode = 2
	else
		mode = 0
	end
	new_navcomm(mode, radioalt, nav1, nav1stby, com1, com1stby, outsideAT, baro)
end

-- Switches, buttons and dials --
button_zoomplus = button_add("zoomplus.png","zoompluspr.png",533,314,28,28, new_zoomplus)
button_zoommin = button_add("zoommin.png","zoomminpres.png",533,358,28,28, new_zoommin)
button_home = button_add("homebutton.png","homebuttonpr.png",527,391,40,35, new_home)

button_add("zoomplus.png","zoompluspr.png",15,72,28,28, AIRP_Active)
button_add("zoommin.png","zoomminpres.png",15,118,28,28, AIRP_Inactive)
button_add("zoomplus.png","zoompluspr.png",15,152,28,28, VOR_Active)
button_add("zoommin.png","zoomminpres.png",15,196,28,28, VOR_Inactive)
button_add("zoomplus.png","zoompluspr.png",15,232,28,28, NDB_Active)
button_add("zoommin.png","zoomminpres.png",15,278,28,28, NDB_Inactive)
button_add("zoomplus.png","zoompluspr.png",15,312,28,28, FIX_Active)
button_add("zoommin.png","zoomminpres.png",15,358,28,28, FIX_Inactive)
button_add("zoomplus.png","zoompluspr.png",533,232,28,28, MAP_Up)
button_add("zoommin.png","zoomminpres.png",533,278,28,28, MAP_Down)
-------------------
-- Bus subscribe --
-------------------
xpl_dataref_subscribe("sim/flightmodel/position/latitude", "DOUBLE",
			  "sim/flightmodel/position/longitude", "DOUBLE", 
			  "sim/flightmodel/position/mag_psi", "FLOAT",
			  "sim/flightmodel/position/groundspeed", "FLOAT", 
			  "sim/time/total_flight_time_sec", "FLOAT", new_position)
xpl_dataref_subscribe("sim/cockpit/radios/transponder_mode", "INT", 
			  "sim/cockpit2/gauges/indicators/radio_altimeter_height_ft_pilot", "FLOAT", 
			  "sim/cockpit/radios/nav1_freq_hz", "INT", 
			  "sim/cockpit/radios/nav1_stdby_freq_hz", "INT", 
			  "sim/cockpit/radios/com1_freq_hz", "INT", 
			  "sim/cockpit/radios/com1_stdby_freq_hz", "INT", 
			  "sim/cockpit2/temperature/outside_air_temp_degc", "FLOAT", 
			  "sim/cockpit/misc/barometer_setting", "FLOAT", new_navcomm)
fsx_variable_subscribe("GPS POSITION LAT", "Degrees",
					   "GPS POSITION LON", "Degrees",
					   "PLANE HEADING DEGREES MAGNETIC", "Degrees",
					   "GPS GROUND SPEED", "Knots", new_position)
fsx_variable_subscribe("TRANSPONDER CODE:1", "Number",
					   "GPS POSITION ALT", "Feet",
					   "NAV ACTIVE FREQUENCY:1", "KHz",
					   "NAV STANDBY FREQUENCY:1", "KHz",
					   "COM ACTIVE FREQUENCY:1", "KHz",
					   "COM STANDBY FREQUENCY:1", "KHz",
					   "AMBIENT TEMPERATURE", "Celsius",
					   "KOHLSMAN SETTING HG", "inHg", new_navcomm_FSX)